//This file contains the textures for the fish.

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"


#declare BezFlatness = 0
#declare BezUStep    = 4
#declare BezVStep    = 4

// *******  T E X T U R E S  *******

//  $MRY$: 'fishtex'
#declare fishtex =
texture {
  finish {
    ambient   0.10
    diffuse   0.50
    phong   1.00
    phong_size  20.00
    specular  1.0000
    roughness  0.0001

  }
  pigment {
  gradient <1, 0, 0>
    turbulence .1
    color_map {
      [0.0, 0.01 color Black color Black]
      [0.01, 0.15 color Black color Red]
      [0.15, 0.29 color Red color Black]
      [0.29, 0.3 color Black color Black]
      [0.3, 1.0 color White color White]

  }
  scale <2.5, 1, 1>
  translate <2, 0, 0>
 }
}




//  $MRY$: 'pupiltex'
#declare pupiltex = texture {
 pigment { color red  0.000 green  0.000 blue  0.000 }
 finish {
  ambient   0.00
  diffuse   0.00
 }
}




//  $MRY$: 'fishmaptex'
#declare fishmaptex = texture {
  finish {
    ambient   0.10
    diffuse   0.60
    brilliance   1.00
    phong   1.00
    phong_size  10.00
    specular  1.0000
    roughness  0.0001

  }
  pigment {
    image_map {
      gif "copper2.gif" map_type 0 interpolate 2
    }
  }
  normal {
    bump_map {
      gif "bumpmap1.gif" map_type 0 bump_size .5 interpolate 2
    }
    scale <1, .925, 1>
  }
  scale <5, 5, 5>
}



//  $MRY$: 'tailtex'
#declare tailtex = texture {
 pigment { color White filter .5 }
 finish {
  ambient   0.10
  diffuse   0.50
  phong   0.60
  phong_size  20.00
 }
}



//  $MRY$: 'pectexmap'
#declare pectexmap = texture {
  finish {
    ambient   0.10
    diffuse   0.50
    phong   1.00
    phong_size  20.00
    specular  1.0000
    roughness  0.0001

  }
 pigment {
   image_map {gif "pecfnmap.gif" map_type 0 interpolate 2}
  }
  normal {
   bump_map {gif "pecfnbmp.gif" map_type 0 bump_size 2 interpolate 2}
  }
}



//  $MRY$: 'finmattex'
#declare finmattex = texture {
    material_map {
    gif "finmat.gif" map_type 0 interpolate 2
    texture {
    pigment {color White}
    finish {
      ambient   0.10
      diffuse   0.50
      phong   1.00
      phong_size  20.00
      specular  1.0000
      roughness  0.0001
    }
  }
  texture {
    pigment {
      gradient <1, 0, 0>
        color_map {
          [0.0, 0.4 color White filter 1.0 color White filter 0.9]
          [0.4, 0.61 color White filter 0.9 color White filter 0.5]
          [0.61, 1.0 color White filter 0.5 color White filter 0.0]
        }

    }
    finish {
      ambient   0.10
      diffuse   0.50
      phong   1.00
      phong_size  20.00
      specular  1.0000
      roughness  0.0001
    }
  }
 }
}

//  $MRY$: 'sidefinmattex'
#declare sidefinmattex = texture {
  material_map {
    gif "finmat.gif" map_type 0 interpolate 2
    texture {
    pigment {color White}
    finish {
      ambient   0.10
      diffuse   0.50
      phong   1.00
      phong_size  20.00
      specular  1.0000
      roughness  0.0001
    }
  }
  texture {
    pigment {
      gradient <-1, 0, 0>
        color_map {
          [0.0, 1.0 color White filter 0.5 color White filter 0.9]
        }

    }
    finish {
      ambient   0.10
      diffuse   0.50
      phong   1.00
      phong_size  20.00
      specular  1.0000
      roughness  0.0001
    }
  }
 }
}
#declare sidefinmattex = texture {
  material_map {
    gif "finmat.gif" map_type 0 interpolate 2
    texture {
    pigment {color White}
    finish {
      ambient   0.10
      diffuse   0.50
      phong   1.00
      phong_size  20.00
      specular  1.0000
      roughness  0.0001
    }
  }
  texture {
    pigment {
      gradient <-1, 0, 0>
        color_map {
          [0.0, 1.0 color White filter 0.5 color White filter 0.9]
        }

    }
    finish {
      ambient   0.10
      diffuse   0.50
      phong   1.00
      phong_size  20.00
      specular  1.0000
      roughness  0.0001
    }
  }
 }
}

camera {  //  Camera Camera01
  location  <21.254, -60.354, 5.000>
  direction <0.0,     0.0,  2.4880>
  sky       <0.0,     0.0,  1.0>  // Use right handed-system!
  up        <0.0,     0.0,  1.0>  // Where Z is up
  right     <1.3333,  0.0,  0.0>
  look_at   <0.000, 0.000, 0.000>
}

// *******  L I G H T S *******
/*object {   // Light source Light001
  light_source {
    <-8.117, -14.470, 6.380>
    color  red 1.000 green 1.000 blue 1.000
  }
}*/


// ********  O B J E C T S *******
#declare fishbodypatch1 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-0.053207, 0.000790, 8.034649>  <-0.053207, -0.204070, 8.034649>  <-0.045686, -0.839136, 1.851693>  <-0.079846, -0.839136, -0.073891>
    <-7.820454, 0.000790, 8.124299>  <-7.820454, -0.204070, 8.124299>  <-5.505897, -0.839136, 1.557865>  <-5.522537, -0.839136, -0.048530>
    <-7.846081, 0.000790, 0.262524>  <-7.846081, -0.204070, 0.262524>  <-7.841059, -0.335546, 0.169068>  <-7.842614, -0.335546, 0.069869>
    <-9.914493, -0.011719, 1.094550>  <-9.914493, -0.060208, 1.091422>  <-9.903977, -0.028123, 0.201230>  <-9.905956, -0.028123, 0.077567>  }
}
#declare fishbodypatch2 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-0.079846, -0.839136, -0.073891>  <-0.114007, -0.839136, -1.999475>  <-0.100037, -0.171602, -6.036417>  <-0.100037, -0.007327, -6.036417>
    <-5.522537, -0.839136, -0.048530>  <-5.539177, -0.839136, -1.654924>  <-7.816932, -0.171602, -5.953656>  <-7.816932, -0.007327, -5.953656>
    <-7.842614, -0.335546, 0.069869>  <-7.844169, -0.335546, -0.029331>  <-7.842477, -0.171602, -0.102761>  <-7.842477, -0.007327, -0.102761>
    <-9.905956, -0.028123, 0.077567>  <-9.907936, -0.028123, -0.046096>  <-9.905891, -0.027740, -0.991266>  <-9.905891, -0.001072, -0.988139>  }
}
#declare fishbodypatch3 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-0.100037, -0.007327, -6.036417>  <-0.100037, 0.156948, -6.036417>  <-0.114007, 0.792014, -1.999475>  <-0.079846, 0.792014, -0.073891>
    <-7.816932, -0.007327, -5.953656>  <-7.816932, 0.156948, -5.953656>  <-5.539177, 0.792014, -1.654924>  <-5.522537, 0.792014, -0.048530>
    <-7.842477, -0.007327, -0.102761>  <-7.842477, 0.156948, -0.102761>  <-7.844169, 0.303236, -0.029331>  <-7.842614, 0.303236, 0.069869>
    <-9.905891, -0.001072, -0.988139>  <-9.905891, 0.025596, -0.985011>  <-9.907936, 0.031040, -0.037763>  <-9.905956, 0.031040, 0.085901>  }
}
#declare fishbodypatch4 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-0.079846, 0.792014, -0.073891>  <-0.045686, 0.792014, 1.851693>  <-0.053207, 0.205651, 8.034649>  <-0.053207, 0.000790, 8.034649>
    <-5.522537, 0.792014, -0.048530>  <-5.505897, 0.792014, 1.557865>  <-7.820454, 0.205651, 8.124299>  <-7.820454, 0.000790, 8.124299>
    <-7.842614, 0.303236, 0.069869>  <-7.841059, 0.303236, 0.169068>  <-7.846081, 0.205651, 0.262524>  <-7.846081, 0.000790, 0.262524>
    <-9.905956, 0.031040, 0.085901>  <-9.903977, 0.031040, 0.209564>  <-9.914493, 0.036769, 1.097677>  <-9.914493, -0.011719, 1.094550>  }
}
#declare fishbodypatch = union {
  object { fishbodypatch1 }
  object { fishbodypatch2 }
  object { fishbodypatch3 }
  object { fishbodypatch4 }
  translate <0.000000, 0.050171, 0.000000>
}

#declare fishbodypatc11 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <0.161107, 0.000790, 8.034649>  <0.161107, -0.204070, 8.034649>  <0.168628, -0.839136, 1.851693>  <0.134468, -0.839136, -0.073891>
    <-10.392223, 0.000790, 8.767241>  <-10.392223, -0.204070, 8.767241>  <-5.505897, -0.839136, 1.557865>  <-5.522537, -0.839136, -0.048530>
    <-8.167552, 0.012215, -0.809047>  <-8.167552, -0.661043, -0.809047>  <-8.162530, -0.792520, -0.902503>  <-8.164085, -0.792520, -1.001702>
    <-14.303018, 0.000790, -0.391381>  <-14.303018, -0.204070, -0.391381>  <-13.198977, -0.290828, -0.964881>  <-13.200957, -0.290828, -1.088545>  }
}
#declare fishbodypatc12 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <0.134468, -0.839136, -0.073891>  <0.100307, -0.839136, -1.999475>  <0.114277, -0.171602, -6.036417>  <0.114277, -0.007327, -6.036417>
    <-5.522537, -0.839136, -0.048530>  <-5.539177, -0.839136, -1.654924>  <-8.674189, -0.171602, -6.382284>  <-8.674189, -0.007327, -6.382284>
    <-8.164085, -0.792520, -1.001702>  <-8.165640, -0.792520, -1.100902>  <-8.163948, -0.171602, -1.174331>  <-8.163948, -0.007327, -1.174331>
    <-13.200957, -0.290828, -1.088545>  <-13.202937, -0.290828, -1.212208>  <-14.294416, -0.171602, -1.528284>  <-14.294416, -0.007327, -1.528284>  }
}
#declare fishbodypatc13 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <0.114277, -0.007327, -6.036417>  <0.114277, 0.156948, -6.036417>  <0.100307, 0.792014, -1.999475>  <0.134468, 0.792014, -0.073891>
    <-8.674189, -0.007327, -6.382284>  <-8.674189, 0.156948, -6.382284>  <-5.539177, 0.792014, -1.654924>  <-5.522537, 0.792014, -0.048530>
    <-8.163948, -0.007327, -1.174331>  <-8.163948, 0.156948, -1.174331>  <-8.165640, 0.783058, -1.100902>  <-8.164085, 0.783058, -1.001702>
    <-14.294416, -0.007327, -1.528284>  <-14.294416, 0.156948, -1.528284>  <-13.202937, 0.243706, -1.178855>  <-13.200957, 0.243706, -1.055192>  }
}
#declare fishbodypatc14 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <0.134468, 0.792014, -0.073891>  <0.168628, 0.792014, 1.851693>  <0.161107, 0.205651, 8.034649>  <0.161107, 0.000790, 8.034649>
    <-5.522537, 0.792014, -0.048530>  <-5.505897, 0.792014, 1.557865>  <-10.392223, 0.205651, 8.767241>  <-10.392223, 0.000790, 8.767241>
    <-8.164085, 0.783058, -1.001702>  <-8.162530, 0.783058, -0.902503>  <-8.167552, 0.685473, -0.809047>  <-8.167552, 0.012215, -0.809047>
    <-13.200957, 0.243706, -1.055192>  <-13.198977, 0.243706, -0.931528>  <-14.303018, 0.205651, -0.391381>  <-14.303018, 0.000790, -0.391381>  }
}
#declare fishbodypatc1 = union {
  object { fishbodypatc11 }
  object { fishbodypatc12 }
  object { fishbodypatc13 }
  object { fishbodypatc14 }
  rotate <-0.000000, -0.000000, -180.000000>
}

#declare fishbody = union {
  object { fishbodypatch }
  object { fishbodypatc1 }
  scale <0.900000, 1.000000, 1.000000>
}

#declare pectoralpatch1 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-0.874564, -0.009294, 2.393881>  <0.631882, -0.009294, 3.069143>  <1.688154, -0.009294, 3.069143>  <2.969513, -0.009294, 3.012871>
    <-2.000000, -0.004647, 0.999989>  <-1.000000, -0.004647, 0.999989>  <0.000000, -0.004647, 0.999989>  <2.856969, -0.004647, 1.844066>
    <-2.562718, 0.000000, -0.900349>  <-1.000000, 0.000000, 0.000000>  <0.000000, 0.000000, 0.000000>  <1.731533, 0.000000, 0.337631>
    <-3.643200, 0.673792, -4.142458>  <-1.731533, 0.004647, -2.012882>  <-0.337631, 0.004647, -1.112533>  <1.000000, 0.004647, -0.212184>  }
}
#declare pectoralpatch = object {   pectoralpatch1
  texture {
    pectexmap
    scale <10.474444, 6.377111, 6.821608>
    rotate <-94.659119, 132.248138, 7.081922>
    translate <5.260484, 0.815777, 1.022286>
  }
  scale <0.800000, 0.800000, 0.800000>
  rotate <19.969477, -0.000000, -11.637955>
  translate <1.955446, 1.313440, -7.792051>
}

#declare tailpatch1 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-13.433449, 0.012590, 3.752071>  <-12.433449, 0.012590, 3.260949>  <-11.003717, 0.012590, 2.401486>  <-10.003717, 0.012590, 1.061010>
    <-13.924571, 0.007096, 0.542037>  <-12.003717, 0.007096, 0.542037>  <-11.003717, 0.007096, 0.542037>  <-10.003717, 0.007096, 0.315678>
    <-13.924571, 0.001601, -0.457948>  <-12.003717, 0.001601, -0.457948>  <-11.003717, 0.001601, -0.457948>  <-10.003717, 0.001601, -0.259884>
    <-13.372059, -0.003893, -3.667982>  <-12.372059, -0.003893, -3.176860>  <-11.003717, -0.003893, -2.194616>  <-10.003717, -0.003893, -1.005215>  }
}
#declare tailpatch = object {   tailpatch1
  texture {
    finmattex
    scale <10.724591, 10.412826, 11.716067>
    rotate <-270.000000, -0.000000, -0.000000>
    translate <-16.937028, 0.039789, -4.877452>
  }
  translate <1.124528, 0.029822, 0.058315>
}

#declare outereyesphere = object {
  sphere {<0,0,0>,1}
  scale <0.750000, 0.200000, 0.750000>
  rotate <4.175116, -0.000000, 354.787201>
  translate <10.070300, 0.431905, 0.507579>
}

#declare pupilsphere = object {
  sphere {<0,0,0>,1}
  texture {
    pupiltex
  }
  scale <0.400000, 0.100000, 0.400000>
  rotate <4.416892, -0.000000, -6.203704>
  translate <10.092627, 0.575020, 0.520804>
}

#declare eye1 = union {
  object { outereyesphere }
  object { pupilsphere }
  rotate <1.360893, -0.000000, -0.000000>
  translate <-1.157639, 0.000000, -0.082689>
}

#declare outereyesphe1 = object {
  sphere {<0,0,0>,1}
  scale <0.750000, 0.200000, 0.750000>
  rotate <4.175116, -0.000000, 354.787201>
  translate <10.070300, 0.431905, 0.507579>
}

#declare pupilsphere1 = object {
  sphere {<0,0,0>,1}
  texture {
    pupiltex
  }
  scale <0.400000, 0.100000, 0.400000>
  rotate <4.416892, -0.000000, -6.203704>
  translate <10.092627, 0.575020, 0.520804>
}

#declare eye2 = union {
  object { outereyesphe1 }
  object { pupilsphere1 }
  rotate <-0.853110, -0.000000, -171.403610>
  translate <18.730058, 1.540279, -0.077757>
}

#declare analspine1 = object {
  sphere {<0,0,0>,1}
  scale <0.400000, 0.010000, 3.000000>
  rotate <-0.000000, 26.860054, -0.000000>
  translate <-2.772014, 0.000000, -6.307463>
}

#declare analspine2 = object {
  sphere {<0,0,0>,1}
  scale <0.200000, 0.010000, 1.500000>
  rotate <-0.000000, 20.424746, -0.000000>
  translate <-1.958274, 0.000000, -5.932374>
}

#declare dorsalspine1 = object {
  sphere {<0,0,0>,1}
  scale <0.350000, 0.010000, 3.000000>
  rotate <-0.000000, -26.100386, -0.000000>
  translate <-1.252448, 0.000000, 9.324779>
}

#declare dorsalspine2 = object {
  sphere {<0,0,0>,1}
  scale <0.420000, 0.010000, 3.000000>
  rotate <-0.000000, -21.129198, -0.000000>
  translate <-0.659824, 0.000000, 9.314760>
}

#declare dorsalspine3 = object {
  sphere {<0,0,0>,1}
  scale <0.504000, 0.010000, 3.000000>
  rotate <-0.000000, -17.982313, -0.000000>
  translate <0.117956, 0.000000, 9.302057>
}

#declare dorsalspine4 = object {
  sphere {<0,0,0>,1}
  scale <0.504000, 0.010000, 3.000000>
  rotate <-0.000000, -14.267365, -0.000000>
  translate <0.950533, 0.000000, 9.247260>
}

#declare dorsalspine5 = object {
  sphere {<0,0,0>,1}
  scale <0.504000, 0.010000, 3.000000>
  rotate <-0.000000, -11.813030, -0.000000>
  translate <1.838245, 0.000000, 9.158043>
}

#declare dorsalspine7 = object {
  sphere {<0,0,0>,1}
  scale <0.408240, 0.010000, 2.430000>
  rotate <-0.000000, -4.899249, -0.000000>
  translate <3.370407, 0.000000, 8.795239>
}

#declare dorsalspine8 = object {
  sphere {<0,0,0>,1}
  scale <0.367416, 0.010000, 2.187000>
  rotate <-0.000000, -0.273033, -0.000000>
  translate <3.978218, 0.000000, 8.359724>
}

#declare dorsalspine9 = object {
  sphere {<0,0,0>,1}
  scale <0.293933, 0.010000, 1.749600>
  rotate <-0.000000, 3.579628, -0.000000>
  translate <4.555551, 0.000000, 7.887854>
}

#declare dorsalspine10 = object {
  sphere {<0,0,0>,1}
  scale <0.235146, 0.010000, 1.399680>
  rotate <-0.000000, 8.113843, -0.000000>
  translate <5.003019, 0.000000, 7.385063>
}

#declare dorsalspine6 = object {
  sphere {<0,0,0>,1}
  scale <0.453600, 0.010000, 2.700000>
  rotate <-0.000000, -7.139027, -0.000000>
  translate <2.601387, 0.000000, 9.036129>
}

#declare dorsalspines = union {
  object { dorsalspine1 }
  object { dorsalspine2 }
  object { dorsalspine3 }
  object { dorsalspine4 }
  object { dorsalspine5 }
  object { dorsalspine7 }
  object { dorsalspine8 }
  object { dorsalspine9 }
  object { dorsalspine10 }
  object { dorsalspine6 }
  scale <1.083668, 0.950000, 0.916583>
  rotate <-0.000000, 7.862904, -0.000000>
  translate <-1.342611, 0.000000, 1.360942>
}

#declare pectoralpatc11 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-0.874564, -0.009294, 2.393881>  <0.631882, -0.009294, 3.069143>  <1.688154, -0.009294, 3.069143>  <2.969513, -0.009294, 3.012871>
    <-2.000000, -0.004647, 0.999989>  <-1.000000, -0.004647, 0.999989>  <0.000000, -0.004647, 0.999989>  <2.856969, -0.004647, 1.844066>
    <-2.562718, 0.000000, -0.900349>  <-1.000000, 0.000000, 0.000000>  <0.000000, 0.000000, 0.000000>  <1.731533, 0.000000, 0.337631>
    <-3.643200, -1.036245, -4.142458>  <-1.731533, 0.004647, -2.012882>  <-0.337631, 0.004647, -1.112533>  <1.000000, 0.004647, -0.212184>  }
}
#declare pectoralpatc1 = object {   pectoralpatc11
  texture {
    pectexmap
    scale <10.474444, 6.377111, 6.821608>
    rotate <-94.659119, 132.248138, 7.081922>
    translate <5.260484, 0.815777, 1.022286>
  }
  scale <0.800000, 0.800000, 0.800000>
  rotate <-30.257172, -8.835130, -6.680355>
  translate <1.560379, -1.283715, -7.545263>
}

#declare sidefinpatch1 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-7.160986, 3.576524, 2.397867>  <-1.000000, 1.494740, 1.546449>  <0.000000, 1.494740, 1.546449>  <1.180585, 1.494740, 0.426825>
    <-3.635688, 1.489740, 1.215607>  <-1.000000, 1.489740, 0.546462>  <0.000000, 1.489740, 0.546462>  <1.216701, 1.489740, 0.113059>
    <-2.594796, 1.484740, 0.066920>  <-1.000000, 1.484740, -0.453526>  <0.000000, 1.484740, -0.453526>  <1.216701, 1.484740, -0.128474>
    <-1.553903, 1.479740, -1.750911>  <-0.891649, 1.479740, -1.706332>  <0.000000, 1.479740, -1.453513>  <1.144468, 1.479740, -0.550591>  }
}
#declare sidefinpatch = object {   sidefinpatch1
  texture {
    sidefinmattex
    scale <14.726154, 5.638723, 26.966423>
    rotate <-270.000000, -0.000000, -0.000000>
    translate <-9.084055, 1.504730, -2.494564>
  }
  rotate <-0.000000, -0.000000, -21.360031>
  translate <4.343431, -0.517067, -0.371354>
}

#declare sidefinpatch11 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <-6.640540, -0.289647, 2.397867>  <-1.000000, 1.494740, 1.546449>  <0.000000, 1.494740, 1.546449>  <1.180585, 1.494740, 0.426825>
    <-3.635688, 1.489740, 1.215607>  <-1.000000, 1.489740, 0.546462>  <0.000000, 1.489740, 0.546462>  <1.216701, 1.489740, 0.113059>
    <-2.594796, 1.484740, 0.066920>  <-1.000000, 1.484740, -0.453526>  <0.000000, 1.484740, -0.453526>  <1.216701, 1.484740, -0.128474>
    <-1.553903, 1.479740, -1.750911>  <-0.891649, 1.479740, -1.706332>  <0.000000, 1.479740, -1.453513>  <1.144468, 1.479740, -0.550591>  }
}
#declare sidefinpatch1 = object {   sidefinpatch11
  texture {
    sidefinmattex
    scale <14.726154, 5.638723, 26.966423>
    rotate <-270.000000, -0.000000, -0.000000>
    translate <-9.084055, 1.504730, -2.494564>
  }
  rotate <-0.000000, -0.000000, -337.206604>
  translate <4.989764, -2.456067, -0.371354>
}

#declare gillpatch1 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <1.527753, -0.636098, -2.944889>  <-1.370790, -0.732393, -2.547644>  <-1.926090, -0.617162, -0.319859>  <-2.784400, -0.468618, -0.167475>
    <4.079758, -0.365664, -2.091998>  <1.703091, -0.011866, -0.552750>  <0.799742, -0.016258, -0.123866>  <-3.093283, -0.473501, 1.224367>
    <4.149252, -0.368988, -0.861882>  <2.131976, -0.010995, 0.350609>  <1.228627, -0.015387, 0.779493>  <-1.835433, -1.299112, 5.440211>
    <3.759471, -0.378611, 0.845669>  <3.778406, -0.878264, 2.416172>  <2.292047, -1.042194, 3.505329>  <1.237979, -1.047319, 4.005770>  }
}
#declare gillpatch = object {   gillpatch1
  scale <0.600000, 0.600000, 0.800000>
  rotate <1.958592, -0.000000, -10.375690>
  translate <7.357045, 0.994413, -0.605120>
}

#declare gillpatch11 = object {
  bicubic_patch { type 1 flatness BezFlatness u_steps BezUStep v_steps BezVStep
    <1.144504, -0.032269, -3.114960>  <-1.737411, 0.413828, -2.404192>  <-1.795726, 0.339478, -0.137913>  <-3.232490, 0.711225, 0.087833>
    <3.581871, -0.090484, -2.440371>  <1.647307, -0.016134, -0.701649>  <0.785640, -0.016134, -0.194175>  <-3.416524, 0.727360, 1.501526>
    <4.057745, -0.074349, -1.221391>  <2.154715, 0.000000, 0.159906>  <1.293048, 0.000000, 0.667380>  <-1.490469, 1.373767, 5.378902>
    <3.821188, -0.058215, 0.513986>  <3.682221, 0.974484, 1.858259>  <2.594450, 1.038270, 3.070141>  <1.589018, 1.135890, 3.925861>  }
}
#declare gillpatch1 = object {   gillpatch11
  scale <0.600000, 0.600000, 0.800000>
  rotate <4.092361, -0.000000, 13.479308>
  translate <7.485442, -0.846610, -0.605120>
}

#declare analfinsphere = object {
  sphere {<0,0,0>,1}
  scale <3.671643, 0.010000, 7.783871>
  rotate <-0.000000, 22.260298, -0.000000>
  translate <-4.699688, 0.000000, -1.909248>
}

#declare dorsalsphere = object {
  sphere {<0,0,0>,1}
  scale <6.055420, 0.010000, 8.948157>
  rotate <-0.000000, -33.031452, -0.000000>
  translate <-3.338263, 0.000000, 4.932247>
}

#declare dorsalsphere1 = object {
  sphere {<0,0,0>,1}
  scale <12.382659, 0.010000, 16.276329>
  rotate <-0.000000, -22.002117, -0.000000>
  translate <2.898377, 0.000000, 6.812839>
}

#declare dorsalsphere2 = object {
  sphere {<0,0,0>,1}
  scale <13.040835, 0.010000, 13.149990>
  rotate <-0.000000, -22.002117, -0.000000>
  translate <-5.420617, 0.000000, -0.254227>
}

#declare dorsalfin = intersection {
  object { dorsalsphere }
  object { dorsalsphere1 }
  object { dorsalsphere2 }
}

#declare Fish =
 union {
  object { fishbody }
  object { pectoralpatch }
  object { tailpatch }
  object { eye1 }
  object { eye2 }
  object { analspine1 }
  object { analspine2 }
  object { dorsalspines }
  object { pectoralpatc1 }
  object { sidefinpatch }
  object { sidefinpatch1 }
  object { gillpatch }
  object { gillpatch1 }
  object { analfinsphere }
  object { dorsalfin }
  texture {
    fishmaptex
    scale <6.2000, 5.29000, 2.000000>
    rotate <-0.000000, 90.000000, -90.000000>
    rotate <0, -90, 0>
    translate <-16.100000, -2.000000, -10.500000>
  }
}

